// vs_size_box.cc
//
// Copyright 2004 Daniel Burrows

#include "vs_size_box.h"

#include <sigc++/functors/mem_fun.h>

#include <utility>

using namespace std;

vs_size_box::vs_size_box(size s, vscreen_widget *w):min_size(s)
{
  set_subwidget(w);
  set_bg(-1); // Make the background 'invisible'.

  do_layout.connect(sigc::mem_fun(*this, &vs_size_box::layout_me));
}

int vs_size_box::width_request()
{
  vscreen_widget *child=get_subwidget();

  if(child)
    return max(child->width_request(), min_size.w);
  else
    return min_size.w;
}

int vs_size_box::height_request(int w)
{
  vscreen_widget *child=get_subwidget();

  if(child)
    return max(child->height_request(w), min_size.h);
  else
    return min_size.h;
}

void vs_size_box::layout_me()
{
  if(get_subwidget())
    {
      if(get_subwidget()->get_visible())
	get_subwidget()->alloc_size(0, 0, getmaxx(), getmaxy());
      else
	get_subwidget()->alloc_size(0, 0, 0, 0);
    }
}
